1000 REM  ***********************************************
1010 REM  ***********************************************
1020 REM  **
1030 REM  **       EPSON MX-80 PLOTTING PROGRAM
1040 REM  **
1050 REM  ***********************************************
1060 REM  ***********************************************
1070 REM
1080 REM
1090 REM  ***********************************************
1100 REM  * ENTER DATA FROM DISK FILE W/OPTIONAL PRINTOUT
1110 REM  ***********************************************
1120 REM
1130 DIM X(101),Y(101)
1140 INPUT "WHAT IS DESIGNATION OF DATA FILE? ";DAT$
1150 OPEN "I",1,DAT$
1160 FOR I=1 TO 101
1170 INPUT #1,X(I),Y(I)
1180 ON ERROR GOTO 1200
1190 NEXT I
1200 CLOSE #1
1210 INPUT "DO YOU WANT TO LIST THE DATA ?--(Y)ES/(N)O";L$
1220 IF LEFT$(L$,1)="Y" THEN 1230 ELSE 1330
1230 LPRINT CHR$(12)
1240 LPRINT :LPRINT :LPRINT "         DATA":LPRINT 
1250 LPRINT "   X               Y":LPRINT 
1260 FOR I=1 TO 101
1270 LPRINT X(I),Y(I)
1280 ON ERROR GOTO 1330
1290 NEXT I
1300 LPRINT CHR$(12)
1310 REM
1320 REM
1330 REM  ***********************************************
1340 REM  *     PLOT PROGRAM FOR MX-80 PRINTER
1350 REM  *  BY L. J. BERGOLI--BYTE MARCH, 1982
1360 REM  * (MODIFICATIONS TO DATA INPUT-LINES TO 1300)
1370 REM  ***********************************************
1380 REM
1390 REM  ***********************************************
1400 REM  *  ENTER TITLE OF PLOT AND AXIS TITLES
1410 REM  ***********************************************
1420 REM
1430 XTITLE$=SPACE$(50):YTITLE$=SPACE$(50):PTITLE$=SPACE$(50)
1440 LINE INPUT "ENTER TITLE OF PLOT (50 CHAR OR LESS) ";T$
1450 LINE INPUT "ENTER Y AXIS TITLE (50 CHAR OR LESS) ";Y$
1460 LINE INPUT "ENTER X AXIS TITLE (50 CHAR OR LESS) ";X$
1470 MID$(YTITLE$,(LEN(YTITLE$)-LEN(Y$))/2)=Y$
1480 MID$(XTITLE$,(LEN(XTITLE$)-LEN(X$))/2)=X$
1490 MID$(PTITLE$,(LEN(PTITLE$)-LEN(T$))/2)=T$
1500 INPUT "DO YOU WANT (A)UTO OR (M)ANUAL SCALING? ";Y$
1510 IF Y$="M" THEN 1540
1520 IF Y$="A" THEN GOSUB 2810 ELSE 1500
1530 GOTO 1680
1540 INPUT "ENTER MAXIMUM VALUE OF Y AXIS";YMAX
1550 INPUT "ENTER MINIMUN VALUE OF Y AXIS";YMIN
1560 INPUT "ENTER MAXIMUM VALUE OF X AXIS";XMAX
1570 INPUT "ENTER MINIMUM VALUE OF X AXIS";XMIN
1580 REM
1590 REM  ***********************************************
1600 REM  *  MAIN BODY OF PROGRAM STARTS HERE
1610 REM  ***********************************************
1620 REM
1630 REM 
1640 REM  ***********************************************
1650 REM  *  SPEED UP MODIFICATIONS USING SORT ROUTINE
1660 REM  ***********************************************
1670 REM
1680 LPRINT :LPRINT :LPRINT TAB(15);PTITLE$:REM
1690 TOP=100:TEMPTOP=100
1700 GOSUB 3150:REM
1710 LPRINT :LPRINT 
1720 GOSUB 2050:REM
1730 LSPACE=2:GOSUB 2020:REM
1740 RSTOP=20:CHAR$="|":GOSUB 2090:REM
1750 FOR LNNO=100 TO 0 STEP -1
1760 YN=YMAX-(((YMAX-YMIN)/100)*(100-LNNO)):REM
1770 YD=ABS((YMAX-YMIN)/100):REM
1780 GOSUB 2510:REM
1790 IF LNNO/2-FIX(LNNO/2)=0 THEN GOSUB 2150:REM
1800 GOSUB 2260:REM
1810 GOSUB 2400:REM
1820 LPRINT 
1830 RSTOP=20:CHAR$="|":GOSUB 2090:REM
1840 LPRINT 
1850 NEXT LNNO
1860 GOSUB 2610:REM
1870 GOSUB 2720:REM
1880 LSPACE=12:GOSUB 2020:REM
1890 GOSUB 2070:REM
1900 FOR I=1 TO 23:LPRINT :NEXT I:REM
1910 END
1920 REM
1930 REM  ***********************************************
1940 REM  * END OF MAIN BODY-SUBROUTINES START HERE
1950 REM  ***********************************************
1960 REM
1970 REM
1980 REM  ***********************************************
1990 REM  *   PRINTER CONTROL SUBROUTINES
2000 REM  ***********************************************
2010 REM
2020 LPRINT CHR$(27)"A"CHR$(LSPACE)CHR$(27)"2":REM
2030 RETURN:REM
2040 REM
2050 LPRINT CHR$(15):RETURN:REM
2060 REM
2070 LPRINT CHR$(18):RETURN:REM
2080 REM
2090 LPRINT SPC(RSTOP);CHAR$;:RETURN:REM
2100 REM
2110 REM  ***********************************************
2120 REM  *  PLOT VERTICAL LINE SUBROUTINE
2130 REM  ***********************************************
2140 REM
2150 CHAR$="|":RSTOP=20:LPRINT CHR$(13);:GOSUB 2090
2160 RSTOP=9
2170 FOR I=1 TO 10
2180 GOSUB 2090
2190 NEXT I
2200 RETURN
2210 REM
2220 REM  ***********************************************
2230 REM  *  PLOT SORTED DATA SUBROUTINE
2240 REM  ***********************************************
2250 REM
2260 CHAR$="0"
2270 FOR I=TOP TO 0 STEP -1
2280 IF Y(I)>YN+.50001*YD THEN 2340
2290 IF Y(I)<YN-.5*YD THEN I=0:GOTO 2340
2300 TEMPTOP=I
2310 XP=FIX((X(I)-XMIN)*100/(XMAX-XMIN))
2320 IF XP<0 OR XP>100 THEN 2340
2330 LPRINT CHR$(13);:RSTOP=XP+20:GOSUB 2090
2340 NEXT I:TOP=TEMPTOP:RETURN
2350 REM
2360 REM  ***********************************************
2370 REM  * PLOT Y SCALE AND HORIZONTAL LINE SUBROUTINE
2380 REM  ***********************************************
2390 REM
2400 IF LNNO/10-FIX(LNNO/10)<>0 THEN RETURN
2410 LPRINT CHR$(13);:RSTOP=10:CHAR$=" ":GOSUB 2090
2420 LPRINT USING "######.##";(YMAX-YMIN)*LNNO/100+YMIN
2430 LPRINT CHR$(13);:RSTOP=20:CHAR$="-":GOSUB 2090
2440 LPRINT STRING$(100,"-");
2450 RETURN
2460 REM
2470 REM  ***********************************************
2480 REM  *   PRINT Y-AXIS TITLE
2490 REM  ***********************************************
2500 REM
2510 IF LNNO/2-FIX(LNNO/2)<>0 THEN RETURN
2520 LPRINT CHR$(13);:RSTOP=7
2530 CHAR$=MID$(YTITLE$,FIX(((100-LNNO)/2)+1),1)
2540 GOSUB 2090
2550 RETURN
2560 REM
2570 REM  ***********************************************
2580 REM  *   PRINT X SCALE SUBROUTINE
2590 REM  ***********************************************
2600 REM
2610 LPRINT :LPRINT 
2620 RSTOP=13:CHAR$=" ":GOSUB 2090
2630 FOR I=0 TO 10
2640 LPRINT USING "#######.##";(XMAX-XMIN)*I/10+XMIN;
2650 NEXT I
2660 RETURN
2670 REM
2680 REM  ***********************************************
2690 REM  *   PRINT X-AXIS TITLE
2700 REM  ***********************************************
2710 REM
2720 LPRINT :LPRINT :LPRINT 
2730 LPRINT :LPRINT :LPRINT 
2740 RSTOP=45:CHAR$=XTITLE$:GOSUB 2090
2750 RETURN
2760 REM
2770 REM  ***********************************************
2780 REM  *    AUTO-SCALING SUBROUTINES
2790 REM  ***********************************************
2800 REM
2810 YMAX=Y(0):XMAX=X(0):YMIN=Y(0):XMIN=X(0)
2820 FOR I=1 TO 100:REM
2830 IF Y(I)>YMAX THEN YMAX=Y(I)
2840 IF Y(I)<YMIN THEN YMIN=Y(I)
2850 IF X(I)>XMAX THEN XMAX=X(I)
2860 IF X(I)<XMIN THEN XMIN=X(I)
2870 NEXT I
2880 RESTORE 3090
2890 MSD=(YMAX-YMIN)/10:REM
2900 FOR I=-2 TO 4
2910 FOR K=1 TO 3:READ J
2920 IF MSD<=J*10^(I) THEN MSD=J*10^(I):GOTO 2940
2930 NEXT K:RESTORE 3090:NEXT I
2940 FOR I=10 TO -10 STEP -1
2950 IF (YMAX<=I*MSD)*(YMAX>I*MSD-.99999*MSD) THEN YMAX=I*MSD
2960 NEXT I
2970 YMIN=YMAX-10*MSD
2980 RESTORE 3090:REM
2990 MSD=(XMAX-XMIN)/10:REM
3000 FOR I=-2 TO 4
3010 FOR K=1 TO 3:READ J
3020 IF MSD<=J*10^(I) THEN MSD=J*10^(I):GOTO 3040
3030 NEXT K:RESTORE 3090:NEXT I
3040 FOR I=10 TO -10 STEP-1
3050 IF (XMAX<=I*MSD)*(XMAX>I*MSD-.99999*MSD) THEN XMAX=I*MSD
3060 NEXT I
3070 XMIN=XMAX-10*MSD
3080 RETURN
3090 DATA 1,2,5
3100 REM
3110 REM  ***********************************************
3120 REM  *    SHELL SORT OF DATA
3130 REM  ***********************************************
3140 REM
3150 M=100
3160 REM
3170 M=INT(M/2):IF M=0 THEN RETURN
3180 J=0:K=100-M
3190 I=J
3200 L=I+M:IF Y(I)<Y(L) THEN 3230
3210 T=Y(I):T1=X(I):Y(I)=Y(L):X(I)=X(L):Y(L)=T:X(L)=T1:I=I-M
3220 IF I<0 THEN 3230 ELSE 3200
3230 J=J+1:IF J<=K THEN 3190 ELSE 3170
3240 REM
3250 REM  ***********************************************
3260 REM  * LIST OF VARIABLE NAMES USED IN PROGRAM
3270 REM  ***********************************************
3280 REM
3290 REM   Y(I)       Y-AXIS DATA
3300 REM   X(I)       X-AXIS DATA
3310 REM   YMAX       MAXIMUM VALUE OF Y-AXIS
3320 REM   YMIN       MINIMUM   "   "    "
3330 REM   XMAX       MAXIMUM VALUE OF X-AXIS
3340 REM   XMIN       MINIMUM   "   "    "
3350 REM   LNNO       Y-AXIS LINE NUMBER
3360 REM   RSTOP      CHARACTER TAB STOP
3370 REM   LSPACE     SIZE OF PRINTER LINEFEED
3380 REM   YN         NORMALIZED Y-AXIS VALUE
3390 REM   YD         Y-AXIS DELTA VALUE
3400 REM   XP         CHARACTER POSITION ON X-AXIS
3410 REM   MSD        MINIMUM SCALE DELTA
3420 REM   J          SCALE DELTA
3430 REM   CHAR$      STRING PRINTED AT RSTOP
3440 REM
3450 REM  ***********************************************
3460 REM  ***********************************************
440 REM
3450 REM  ***********************************************
3460 RE